#region license
// Copyright (c) 2003, 2004, 2005 Rodrigo B. de Oliveira (rbo@acm.org)
// All rights reserved.
// 
// Redistribution and use in source and binary forms, with or without modification,
// are permitted provided that the following conditions are met:
// 
//     * Redistributions of source code must retain the above copyright notice,
//     this list of conditions and the following disclaimer.
//     * Redistributions in binary form must reproduce the above copyright notice,
//     this list of conditions and the following disclaimer in the documentation
//     and/or other materials provided with the distribution.
//     * Neither the name of Rodrigo B. de Oliveira nor the names of its
//     contributors may be used to endorse or promote products derived from this
//     software without specific prior written permission.
// 
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
// ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
// WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
// DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE
// FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
// DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
// SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
// CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
// OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
// THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#endregion

//
// DO NOT EDIT THIS FILE!
//
// This file was generated automatically by astgen.boo.
//

namespace Boo.Lang.Compiler.Ast.Impl
{	
	using Boo.Lang.Compiler.Ast;
	using System.Collections;
	using System.Runtime.Serialization;
	
	[System.Serializable]
	public abstract class BinaryExpressionImpl : Expression
	{
		protected BinaryOperatorType _operator;

		protected Expression _left;

		protected Expression _right;

		protected BinaryExpressionImpl()
		{
			InitializeFields();
		}
		
		protected BinaryExpressionImpl(LexicalInfo info) : base(info)
		{
			InitializeFields();
		}
		
		protected BinaryExpressionImpl(BinaryOperatorType operator_, Expression left, Expression right)
		{
			InitializeFields();
			Operator = operator_;
			Left = left;
			Right = right;
		}
			
		protected BinaryExpressionImpl(LexicalInfo lexicalInfo, BinaryOperatorType operator_, Expression left, Expression right) : base(lexicalInfo)
		{
			InitializeFields();
			Operator = operator_;
			Left = left;
			Right = right;
		}

		new public BinaryExpression CloneNode()
		{
			return Clone() as BinaryExpression;
		}

		override public NodeType NodeType
		{
			get
			{
				return NodeType.BinaryExpression;
			}
		}
		
		override public bool Matches(Node node)
		{	
			BinaryExpression other = node as BinaryExpression;
			if (null == other) return false;
			if (_operator != other._operator) return false;
			if (!Node.Matches(_left, other._left)) return false;
			if (!Node.Matches(_right, other._right)) return false;
			return true;
		}
	
		override public bool Replace(Node existing, Node newNode)
		{
			if (base.Replace(existing, newNode))
			{
				return true;
			}
			if (_left == existing)
			{
				this.Left = (Expression)newNode;
				return true;
			}
			if (_right == existing)
			{
				this.Right = (Expression)newNode;
				return true;
			}
			return false;
		}
		
		override public object Clone()
		{
			BinaryExpression clone = (BinaryExpression)FormatterServices.GetUninitializedObject(typeof(BinaryExpression));
			clone._lexicalInfo = _lexicalInfo;
			clone._endSourceLocation = _endSourceLocation;
			clone._documentation = _documentation;
			//clone._entity = _entity;
			clone._annotations = (Hashtable)_annotations.Clone();
		
			clone._expressionType = _expressionType;
			clone._operator = _operator;
			if (null != _left)
			{
				clone._left = _left.Clone() as Expression;
				clone._left.InitializeParent(clone);
			}
			if (null != _right)
			{
				clone._right = _right.Clone() as Expression;
				clone._right.InitializeParent(clone);
			}
			return clone;
		}
		
		override internal void ClearTypeSystemBindings()
		{
			_annotations.Clear();
			//_entity = null;
			_expressionType = null;
			if (null != _left)
			{
				_left.ClearTypeSystemBindings();
			}
			if (null != _right)
			{
				_right.ClearTypeSystemBindings();
			}

		}
	

		[System.Xml.Serialization.XmlElement]
		public BinaryOperatorType Operator
		{
			get
			{
				return _operator;
			}

			set
			{
				_operator = value;
			}

		}
		

		[System.Xml.Serialization.XmlElement]
		public Expression Left
		{
			get
			{
				return _left;
			}

			set
			{
				if (_left != value)
				{
					_left = value;
					if (null != _left)
					{
						_left.InitializeParent(this);
					}
				}
			}

		}
		

		[System.Xml.Serialization.XmlElement]
		public Expression Right
		{
			get
			{
				return _right;
			}

			set
			{
				if (_right != value)
				{
					_right = value;
					if (null != _right)
					{
						_right.InitializeParent(this);
					}
				}
			}

		}
		
		private void InitializeFields()
		{

		}
	}
}

