#region license
// Copyright (c) 2003, 2004, 2005 Rodrigo B. de Oliveira (rbo@acm.org)
// All rights reserved.
// 
// Redistribution and use in source and binary forms, with or without modification,
// are permitted provided that the following conditions are met:
// 
//     * Redistributions of source code must retain the above copyright notice,
//     this list of conditions and the following disclaimer.
//     * Redistributions in binary form must reproduce the above copyright notice,
//     this list of conditions and the following disclaimer in the documentation
//     and/or other materials provided with the distribution.
//     * Neither the name of Rodrigo B. de Oliveira nor the names of its
//     contributors may be used to endorse or promote products derived from this
//     software without specific prior written permission.
// 
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
// ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
// WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
// DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE
// FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
// DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
// SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
// CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
// OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
// THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#endregion

//
// DO NOT EDIT THIS FILE!
//
// This file was generated automatically by astgen.boo.
//

namespace Boo.Lang.Compiler.Ast.Impl
{	
	using Boo.Lang.Compiler.Ast;
	using System.Collections;
	using System.Runtime.Serialization;
	
	[System.Serializable]
	public abstract class ExpressionPairImpl : Node
	{
		protected Expression _first;

		protected Expression _second;

		protected ExpressionPairImpl()
		{
			InitializeFields();
		}
		
		protected ExpressionPairImpl(LexicalInfo info) : base(info)
		{
			InitializeFields();
		}
		
		protected ExpressionPairImpl(Expression first, Expression second)
		{
			InitializeFields();
			First = first;
			Second = second;
		}
			
		protected ExpressionPairImpl(LexicalInfo lexicalInfo, Expression first, Expression second) : base(lexicalInfo)
		{
			InitializeFields();
			First = first;
			Second = second;
		}

		new public ExpressionPair CloneNode()
		{
			return Clone() as ExpressionPair;
		}

		override public NodeType NodeType
		{
			get
			{
				return NodeType.ExpressionPair;
			}
		}
		
		override public bool Matches(Node node)
		{	
			ExpressionPair other = node as ExpressionPair;
			if (null == other) return false;
			if (!Node.Matches(_first, other._first)) return false;
			if (!Node.Matches(_second, other._second)) return false;
			return true;
		}
	
		override public bool Replace(Node existing, Node newNode)
		{
			if (base.Replace(existing, newNode))
			{
				return true;
			}
			if (_first == existing)
			{
				this.First = (Expression)newNode;
				return true;
			}
			if (_second == existing)
			{
				this.Second = (Expression)newNode;
				return true;
			}
			return false;
		}
		
		override public object Clone()
		{
			ExpressionPair clone = (ExpressionPair)FormatterServices.GetUninitializedObject(typeof(ExpressionPair));
			clone._lexicalInfo = _lexicalInfo;
			clone._endSourceLocation = _endSourceLocation;
			clone._documentation = _documentation;
			//clone._entity = _entity;
			clone._annotations = (Hashtable)_annotations.Clone();
		
			if (null != _first)
			{
				clone._first = _first.Clone() as Expression;
				clone._first.InitializeParent(clone);
			}
			if (null != _second)
			{
				clone._second = _second.Clone() as Expression;
				clone._second.InitializeParent(clone);
			}
			return clone;
		}
		
		override internal void ClearTypeSystemBindings()
		{
			_annotations.Clear();
			//_entity = null;
			if (null != _first)
			{
				_first.ClearTypeSystemBindings();
			}
			if (null != _second)
			{
				_second.ClearTypeSystemBindings();
			}

		}
	

		[System.Xml.Serialization.XmlElement]
		public Expression First
		{
			get
			{
				return _first;
			}

			set
			{
				if (_first != value)
				{
					_first = value;
					if (null != _first)
					{
						_first.InitializeParent(this);
					}
				}
			}

		}
		

		[System.Xml.Serialization.XmlElement]
		public Expression Second
		{
			get
			{
				return _second;
			}

			set
			{
				if (_second != value)
				{
					_second = value;
					if (null != _second)
					{
						_second.InitializeParent(this);
					}
				}
			}

		}
		
		private void InitializeFields()
		{

		}
	}
}

