#region license
// Copyright (c) 2003, 2004, 2005 Rodrigo B. de Oliveira (rbo@acm.org)
// All rights reserved.
// 
// Redistribution and use in source and binary forms, with or without modification,
// are permitted provided that the following conditions are met:
// 
//     * Redistributions of source code must retain the above copyright notice,
//     this list of conditions and the following disclaimer.
//     * Redistributions in binary form must reproduce the above copyright notice,
//     this list of conditions and the following disclaimer in the documentation
//     and/or other materials provided with the distribution.
//     * Neither the name of Rodrigo B. de Oliveira nor the names of its
//     contributors may be used to endorse or promote products derived from this
//     software without specific prior written permission.
// 
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
// ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
// WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
// DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE
// FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
// DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
// SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
// CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
// OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
// THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#endregion

//
// DO NOT EDIT THIS FILE!
//
// This file was generated automatically by astgen.boo.
//

namespace Boo.Lang.Compiler.Ast.Impl
{	
	using Boo.Lang.Compiler.Ast;
	using System.Collections;
	using System.Runtime.Serialization;
	
	[System.Serializable]
	public abstract class StatementModifierImpl : Node
	{
		protected StatementModifierType _type;

		protected Expression _condition;

		protected StatementModifierImpl()
		{
			InitializeFields();
		}
		
		protected StatementModifierImpl(LexicalInfo info) : base(info)
		{
			InitializeFields();
		}
		
		protected StatementModifierImpl(StatementModifierType type, Expression condition)
		{
			InitializeFields();
			Type = type;
			Condition = condition;
		}
			
		protected StatementModifierImpl(LexicalInfo lexicalInfo, StatementModifierType type, Expression condition) : base(lexicalInfo)
		{
			InitializeFields();
			Type = type;
			Condition = condition;
		}

		new public StatementModifier CloneNode()
		{
			return Clone() as StatementModifier;
		}

		override public NodeType NodeType
		{
			get
			{
				return NodeType.StatementModifier;
			}
		}
		
		override public bool Matches(Node node)
		{	
			StatementModifier other = node as StatementModifier;
			if (null == other) return false;
			if (_type != other._type) return false;
			if (!Node.Matches(_condition, other._condition)) return false;
			return true;
		}
	
		override public bool Replace(Node existing, Node newNode)
		{
			if (base.Replace(existing, newNode))
			{
				return true;
			}
			if (_condition == existing)
			{
				this.Condition = (Expression)newNode;
				return true;
			}
			return false;
		}
		
		override public object Clone()
		{
			StatementModifier clone = (StatementModifier)FormatterServices.GetUninitializedObject(typeof(StatementModifier));
			clone._lexicalInfo = _lexicalInfo;
			clone._endSourceLocation = _endSourceLocation;
			clone._documentation = _documentation;
			//clone._entity = _entity;
			clone._annotations = (Hashtable)_annotations.Clone();
		
			clone._type = _type;
			if (null != _condition)
			{
				clone._condition = _condition.Clone() as Expression;
				clone._condition.InitializeParent(clone);
			}
			return clone;
		}
		
		override internal void ClearTypeSystemBindings()
		{
			_annotations.Clear();
			//_entity = null;
			if (null != _condition)
			{
				_condition.ClearTypeSystemBindings();
			}

		}
	

		[System.Xml.Serialization.XmlElement]
		public StatementModifierType Type
		{
			get
			{
				return _type;
			}

			set
			{
				_type = value;
			}

		}
		

		[System.Xml.Serialization.XmlElement]
		public Expression Condition
		{
			get
			{
				return _condition;
			}

			set
			{
				if (_condition != value)
				{
					_condition = value;
					if (null != _condition)
					{
						_condition.InitializeParent(this);
					}
				}
			}

		}
		
		private void InitializeFields()
		{

		}
	}
}

