#region license
// Copyright (c) 2003, 2004, 2005 Rodrigo B. de Oliveira (rbo@acm.org)
// All rights reserved.
// 
// Redistribution and use in source and binary forms, with or without modification,
// are permitted provided that the following conditions are met:
// 
//     * Redistributions of source code must retain the above copyright notice,
//     this list of conditions and the following disclaimer.
//     * Redistributions in binary form must reproduce the above copyright notice,
//     this list of conditions and the following disclaimer in the documentation
//     and/or other materials provided with the distribution.
//     * Neither the name of Rodrigo B. de Oliveira nor the names of its
//     contributors may be used to endorse or promote products derived from this
//     software without specific prior written permission.
// 
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
// ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
// WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
// DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE
// FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
// DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
// SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
// CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
// OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
// THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#endregion

//
// DO NOT EDIT THIS FILE!
//
// This file was generated automatically by astgen.boo.
//

namespace Boo.Lang.Compiler.Ast.Impl
{	
	using Boo.Lang.Compiler.Ast;
	using System.Collections;
	using System.Runtime.Serialization;
	
	[System.Serializable]
	public abstract class TypeMemberImpl : Node, INodeWithAttributes
	{
		protected TypeMemberModifiers _modifiers;

		protected string _name;

		protected AttributeCollection _attributes;

		protected TypeMemberImpl()
		{
			InitializeFields();
		}
		
		protected TypeMemberImpl(LexicalInfo info) : base(info)
		{
			InitializeFields();
		}
		
		protected TypeMemberImpl(TypeMemberModifiers modifiers, string name)
		{
			InitializeFields();
			Modifiers = modifiers;
			Name = name;
		}
			
		protected TypeMemberImpl(LexicalInfo lexicalInfo, TypeMemberModifiers modifiers, string name) : base(lexicalInfo)
		{
			InitializeFields();
			Modifiers = modifiers;
			Name = name;
		}

		new public TypeMember CloneNode()
		{
			return Clone() as TypeMember;
		}

		override public bool Matches(Node node)
		{	
			TypeMember other = node as TypeMember;
			if (null == other) return false;
			if (_modifiers != other._modifiers) return false;
			if (_name != other._name) return false;
			if (!Node.Matches(_attributes, other._attributes)) return false;
			return true;
		}
	
		override public bool Replace(Node existing, Node newNode)
		{
			if (base.Replace(existing, newNode))
			{
				return true;
			}
			if (_attributes != null)
			{
				Attribute item = existing as Attribute;
				if (null != item)
				{
					Attribute newItem = (Attribute)newNode;
					if (_attributes.Replace(item, newItem))
					{
						return true;
					}
				}
			}
			return false;
		}
		
		override public object Clone()
		{
			TypeMember clone = (TypeMember)FormatterServices.GetUninitializedObject(typeof(TypeMember));
			clone._lexicalInfo = _lexicalInfo;
			clone._endSourceLocation = _endSourceLocation;
			clone._documentation = _documentation;
			//clone._entity = _entity;
			clone._annotations = (Hashtable)_annotations.Clone();
		
			clone._modifiers = _modifiers;
			clone._name = _name;
			if (null != _attributes)
			{
				clone._attributes = _attributes.Clone() as AttributeCollection;
				clone._attributes.InitializeParent(clone);
			}
			return clone;
		}
		
		override internal void ClearTypeSystemBindings()
		{
			_annotations.Clear();
			//_entity = null;
			if (null != _attributes)
			{
				_attributes.ClearTypeSystemBindings();
			}

		}
	

		[System.Xml.Serialization.XmlAttribute,
		System.ComponentModel.DefaultValue(TypeMemberModifiers.None)]
		public TypeMemberModifiers Modifiers
		{
			get
			{
				return _modifiers;
			}

			set
			{
				_modifiers = value;
			}

		}
		

		[System.Xml.Serialization.XmlAttribute]
		public string Name
		{
			get
			{
				return _name;
			}

			set
			{
				_name = value;
			}

		}
		

		[System.Xml.Serialization.XmlElement]
		public AttributeCollection Attributes
		{
			get
			{
				return _attributes;
			}

			set
			{
				if (_attributes != value)
				{
					_attributes = value;
					if (null != _attributes)
					{
						_attributes.InitializeParent(this);
					}
				}
			}

		}
		
		private void InitializeFields()
		{

			_attributes = new AttributeCollection(this);

		}
	}
}

