﻿#region license
// Copyright (c) 2003, 2004, 2005 Rodrigo B. de Oliveira (rbo@acm.org)
// All rights reserved.
// 
// Redistribution and use in source and binary forms, with or without modification,
// are permitted provided that the following conditions are met:
// 
//     * Redistributions of source code must retain the above copyright notice,
//     this list of conditions and the following disclaimer.
//     * Redistributions in binary form must reproduce the above copyright notice,
//     this list of conditions and the following disclaimer in the documentation
//     and/or other materials provided with the distribution.
//     * Neither the name of Rodrigo B. de Oliveira nor the names of its
//     contributors may be used to endorse or promote products derived from this
//     software without specific prior written permission.
// 
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
// ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
// WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
// DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE
// FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
// DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
// SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
// CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
// OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
// THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#endregion


// $ANTLR 2.7.5 (20050517): "src/Boo.Lang.Parser/boo.g" -> "BooParserBase.cs"$

namespace Boo.Lang.Parser
{
	public class BooTokenTypes
	{
		public const int EOF = 1;
		public const int NULL_TREE_LOOKAHEAD = 3;
		public const int INDENT = 4;
		public const int DEDENT = 5;
		public const int ELIST = 6;
		public const int DLIST = 7;
		public const int ESEPARATOR = 8;
		public const int EOL = 9;
		public const int ABSTRACT = 10;
		public const int AND = 11;
		public const int AS = 12;
		public const int AST = 13;
		public const int BREAK = 14;
		public const int CONTINUE = 15;
		public const int CALLABLE = 16;
		public const int CAST = 17;
		public const int CHAR = 18;
		public const int CLASS = 19;
		public const int CONSTRUCTOR = 20;
		public const int DEF = 21;
		public const int DESTRUCTOR = 22;
		public const int DO = 23;
		public const int ELIF = 24;
		public const int ELSE = 25;
		public const int ENSURE = 26;
		public const int ENUM = 27;
		public const int EVENT = 28;
		public const int EXCEPT = 29;
		public const int FAILURE = 30;
		public const int FINAL = 31;
		public const int FROM = 32;
		public const int FOR = 33;
		public const int FALSE = 34;
		public const int GET = 35;
		public const int GIVEN = 36;
		public const int GOTO = 37;
		public const int IMPORT = 38;
		public const int INTERFACE = 39;
		public const int INTERNAL = 40;
		public const int IS = 41;
		public const int ISA = 42;
		public const int IF = 43;
		public const int IN = 44;
		public const int NOT = 45;
		public const int NULL = 46;
		public const int OF = 47;
		public const int OR = 48;
		public const int OTHERWISE = 49;
		public const int OVERRIDE = 50;
		public const int PASS = 51;
		public const int NAMESPACE = 52;
		public const int PARTIAL = 53;
		public const int PUBLIC = 54;
		public const int PROTECTED = 55;
		public const int PRIVATE = 56;
		public const int RAISE = 57;
		public const int REF = 58;
		public const int RETURN = 59;
		public const int RETRY = 60;
		public const int SET = 61;
		public const int SELF = 62;
		public const int SUPER = 63;
		public const int STATIC = 64;
		public const int SUCCESS = 65;
		public const int STRUCT = 66;
		public const int TRY = 67;
		public const int TRANSIENT = 68;
		public const int TRUE = 69;
		public const int TYPEOF = 70;
		public const int UNLESS = 71;
		public const int VIRTUAL = 72;
		public const int WHEN = 73;
		public const int WHILE = 74;
		public const int YIELD = 75;
		public const int TRIPLE_QUOTED_STRING = 76;
		public const int EOS = 77;
		public const int DOUBLE_QUOTED_STRING = 78;
		public const int SINGLE_QUOTED_STRING = 79;
		public const int ID = 80;
		public const int LPAREN = 81;
		public const int RPAREN = 82;
		public const int ASSIGN = 83;
		public const int SUBTRACT = 84;
		public const int LBRACK = 85;
		public const int COMMA = 86;
		public const int RBRACK = 87;
		public const int ASSEMBLY_ATTRIBUTE_BEGIN = 88;
		public const int DOT = 89;
		public const int COLON = 90;
		public const int MULTIPLY = 91;
		public const int BITWISE_OR = 92;
		public const int LBRACE = 93;
		public const int RBRACE = 94;
		public const int INPLACE_BITWISE_OR = 95;
		public const int INPLACE_BITWISE_AND = 96;
		public const int INPLACE_SHIFT_LEFT = 97;
		public const int INPLACE_SHIFT_RIGHT = 98;
		public const int CMP_OPERATOR = 99;
		public const int GREATER_THAN = 100;
		public const int LESS_THAN = 101;
		public const int ADD = 102;
		public const int EXCLUSIVE_OR = 103;
		public const int DIVISION = 104;
		public const int MODULUS = 105;
		public const int BITWISE_AND = 106;
		public const int SHIFT_LEFT = 107;
		public const int SHIFT_RIGHT = 108;
		public const int EXPONENTIATION = 109;
		public const int INCREMENT = 110;
		public const int DECREMENT = 111;
		public const int ONES_COMPLEMENT = 112;
		public const int INT = 113;
		public const int LONG = 114;
		public const int RE_LITERAL = 115;
		public const int DOUBLE = 116;
		public const int FLOAT = 117;
		public const int TIMESPAN = 118;
		public const int LINE_CONTINUATION = 119;
		public const int SL_COMMENT = 120;
		public const int ML_COMMENT = 121;
		public const int WS = 122;
		public const int X_RE_LITERAL = 123;
		public const int NEWLINE = 124;
		public const int ESCAPED_EXPRESSION = 125;
		public const int DQS_ESC = 126;
		public const int SQS_ESC = 127;
		public const int SESC = 128;
		public const int RE_CHAR = 129;
		public const int X_RE_CHAR = 130;
		public const int RE_ESC = 131;
		public const int DIGIT_GROUP = 132;
		public const int REVERSE_DIGIT_GROUP = 133;
		public const int ID_PREFIX = 134;
		public const int ID_LETTER = 135;
		public const int DIGIT = 136;
		public const int HEXDIGIT = 137;
		
	}
}
