
namespace BooCompiler.Tests
{
	using NUnit.Framework;
	using Boo.Lang.Compiler;	

	[TestFixture]
	public class CompilerErrorsTestFixture : AbstractCompilerTestCase
	{			
		public class PrintErrors : Boo.Lang.Compiler.Pipelines.Compile
		{
			override public void Run(CompilerContext context)
			{
				base.Run(context);
				RunStep(context, new Boo.Lang.Compiler.Steps.PrintErrors());
			}
		}
		
		protected override CompilerPipeline SetUpCompilerPipeline()
		{
			return new PrintErrors();
		}
		
		protected override bool IgnoreErrors
		{
			get
			{
				return true;
			}
		}

		[Test]
		public void BCE0000_1()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0000-1.boo");
		}
		
		[Test]
		public void BCE0004_2()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0004-2.boo");
		}
		
		[Test]
		public void BCE0005_1()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0005-1.boo");
		}
		
		[Test]
		public void BCE0005_2()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0005-2.boo");
		}
		
		[Test]
		public void BCE0006_1()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0006-1.boo");
		}
		
		[Test]
		public void BCE0017_1()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0017-1.boo");
		}
		
		[Test]
		public void BCE0017_2()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0017-2.boo");
		}
		
		[Test]
		public void BCE0017_3()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0017-3.boo");
		}
		
		[Test]
		public void BCE0018_1()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0018-1.boo");
		}
		
		[Test]
		public void BCE0020_1()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0020-1.boo");
		}
		
		[Test]
		public void BCE0020_2()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0020-2.boo");
		}
		
		[Test]
		public void BCE0021_1()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0021-1.boo");
		}
		
		[Test]
		public void BCE0022_1()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0022-1.boo");
		}
		
		[Test]
		public void BCE0022_10()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0022-10.boo");
		}
		
		[Test]
		public void BCE0022_2()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0022-2.boo");
		}
		
		[Test]
		public void BCE0022_3()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0022-3.boo");
		}
		
		[Test]
		public void BCE0022_4()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0022-4.boo");
		}
		
		[Test]
		public void BCE0022_5()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0022-5.boo");
		}
		
		[Test]
		public void BCE0022_6()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0022-6.boo");
		}
		
		[Test]
		public void BCE0022_7()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0022-7.boo");
		}
		
		[Test]
		public void BCE0022_8()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0022-8.boo");
		}
		
		[Test]
		public void BCE0022_9()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0022-9.boo");
		}
		
		[Test]
		public void BCE0023_1()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0023-1.boo");
		}
		
		[Test]
		public void BCE0024_1()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0024-1.boo");
		}
		
		[Test]
		public void BCE0024_2()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0024-2.boo");
		}
		
		[Test]
		public void BCE0024_3()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0024-3.boo");
		}
		
		[Test]
		public void BCE0024_4()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0024-4.boo");
		}
		
		[Test]
		public void BCE0032_1()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0032-1.boo");
		}
		
		[Test]
		public void BCE0035_1()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0035-1.boo");
		}
		
		[Test]
		public void BCE0035_2()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0035-2.boo");
		}
		
		[Test]
		public void BCE0035_3()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0035-3.boo");
		}
		
		[Test]
		public void BCE0046_1()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0046-1.boo");
		}
		
		[Test]
		public void BCE0047_1()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0047-1.boo");
		}
		
		[Test]
		public void BCE0049_1()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0049-1.boo");
		}
		
		[Test]
		public void BCE0051_1()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0051-1.boo");
		}
		
		[Test]
		public void BCE0053_1()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0053-1.boo");
		}
		
		[Test]
		public void BCE0053_2()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0053-2.boo");
		}
		
		[Test]
		public void BCE0053_3()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0053-3.boo");
		}
		
		[Test]
		public void BCE0057_1()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0057-1.boo");
		}
		
		[Test]
		public void BCE0058_1()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0058-1.boo");
		}
		
		[Test]
		public void BCE0060_1()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0060-1.boo");
		}
		
		[Test]
		public void BCE0060_2()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0060-2.boo");
		}
		
		[Test]
		public void BCE0061_1()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0061-1.boo");
		}
		
		[Test]
		public void BCE0063_1()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0063-1.boo");
		}
		
		[Test]
		public void BCE0063_2()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0063-2.boo");
		}
		
		[Test]
		public void BCE0063_3()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0063-3.boo");
		}
		
		[Test]
		public void BCE0063_4()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0063-4.boo");
		}
		
		[Test]
		public void BCE0065_1()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0065-1.boo");
		}
		
		[Test]
		public void BCE0067_1()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0067-1.boo");
		}
		
		[Test]
		public void BCE0067_2()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0067-2.boo");
		}
		
		[Test]
		public void BCE0067_3()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0067-3.boo");
		}
		
		[Test]
		public void BCE0070_1()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0070-1.boo");
		}
		
		[Test]
		public void BCE0070_2()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0070-2.boo");
		}
		
		[Test]
		public void BCE0070_3()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0070-3.boo");
		}
		
		[Test]
		public void BCE0071_1()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0071-1.boo");
		}
		
		[Test]
		public void BCE0071_2()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0071-2.boo");
		}
		
		[Test]
		public void BCE0072_1()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0072-1.boo");
		}
		
		[Test]
		public void BCE0072_2()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0072-2.boo");
		}
		
		[Test]
		public void BCE0073_1()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0073-1.boo");
		}
		
		[Test]
		public void BCE0079_1()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0079-1.boo");
		}
		
		[Test]
		public void BCE0080_1()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0080-1.boo");
		}
		
		[Test]
		public void BCE0081_1()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0081-1.boo");
		}
		
		[Test]
		public void BCE0081_2()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0081-2.boo");
		}
		
		[Test]
		public void BCE0081_3()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0081-3.boo");
		}
		
		[Test]
		public void BCE0081_4()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0081-4.boo");
		}
		
		[Test]
		public void BCE0081_5()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0081-5.boo");
		}
		
		[Test]
		public void BCE0082_1()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0082-1.boo");
		}
		
		[Test]
		public void BCE0083_1()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0083-1.boo");
		}
		
		[Test]
		public void BCE0084_1()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0084-1.boo");
		}
		
		[Test]
		public void BCE0085_1()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0085-1.boo");
		}
		
		[Test]
		public void BCE0085_2()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0085-2.boo");
		}
		
		[Test]
		public void BCE0085_3()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0085-3.boo");
		}
		
		[Test]
		public void BCE0086_1()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0086-1.boo");
		}
		
		[Test]
		public void BCE0087_1()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0087-1.boo");
		}
		
		[Test]
		public void BCE0088_1()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0088-1.boo");
		}
		
		[Test]
		public void BCE0089_1()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0089-1.boo");
		}
		
		[Test]
		public void BCE0089_10()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0089-10.boo");
		}
		
		[Test]
		public void BCE0089_11()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0089-11.boo");
		}
		
		[Test]
		public void BCE0089_12()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0089-12.boo");
		}
		
		[Test]
		public void BCE0089_13()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0089-13.boo");
		}
		
		[Test]
		public void BCE0089_2()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0089-2.boo");
		}
		
		[Test]
		public void BCE0089_3()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0089-3.boo");
		}
		
		[Test]
		public void BCE0089_4()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0089-4.boo");
		}
		
		[Test]
		public void BCE0089_5()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0089-5.boo");
		}
		
		[Test]
		public void BCE0089_6()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0089-6.boo");
		}
		
		[Test]
		public void BCE0089_7()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0089-7.boo");
		}
		
		[Test]
		public void BCE0089_8()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0089-8.boo");
		}
		
		[Test]
		public void BCE0089_9()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0089-9.boo");
		}
		
		[Test]
		public void BCE0090_1()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0090-1.boo");
		}
		
		[Test]
		public void BCE0090_2()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0090-2.boo");
		}
		
		[Test]
		public void BCE0091_1()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0091-1.boo");
		}
		
		[Test]
		public void BCE0092_1()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0092-1.boo");
		}
		
		[Test]
		public void BCE0093_1()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0093-1.boo");
		}
		
		[Test]
		public void BCE0093_2()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0093-2.boo");
		}
		
		[Test]
		public void BCE0094_1()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0094-1.boo");
		}
		
		[Test]
		public void BCE0095_1()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0095-1.boo");
		}
		
		[Test]
		public void BCE0095_2()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0095-2.boo");
		}
		
		[Test]
		public void BCE0096_1()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0096-1.boo");
		}
		
		[Test]
		public void BCE0097_1()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0097-1.boo");
		}
		
		[Test]
		public void BCE0097_2()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0097-2.boo");
		}
		
		[Test]
		public void BCE0099_1()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0099-1.boo");
		}
		
		[Test]
		public void BCE0100_1()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0100-1.boo");
		}
		
		[Test]
		public void BCE0101_1()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0101-1.boo");
		}
		
		[Test]
		public void BCE0102_1()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0102-1.boo");
		}
		
		[Test]
		public void BCE0103_1()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0103-1.boo");
		}
		
		[Test]
		public void BCE0103_2()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0103-2.boo");
		}
		
		[Test]
		public void BCE0103_3()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0103-3.boo");
		}
		
		[Test]
		public void BCE0104_1()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0104-1.boo");
		}
		
		[Test]
		public void BCE0105_1()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0105-1.boo");
		}
		
		[Test]
		public void BCE0107_1()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0107-1.boo");
		}
		
		[Test]
		public void BCE0108_1()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0108-1.boo");
		}
		
		[Test]
		public void BCE0111_1()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0111-1.boo");
		}
		
		[Test]
		public void BCE0112_1()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0112-1.boo");
		}
		
		[Test]
		public void BCE0114_1()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0114-1.boo");
		}
		
		[Test]
		public void BCE0115_1()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0115-1.boo");
		}
		
		[Test]
		public void BCE0116_1()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0116-1.boo");
		}
		
		[Test]
		public void BCE0117_1()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0117-1.boo");
		}
		
		[Test]
		public void BCE0120_1()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0120-1.boo");
		}
		
		[Test]
		public void BCE0120_2()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0120-2.boo");
		}
		
		[Test]
		public void BCE0120_3()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0120-3.boo");
		}
		
		[Test]
		public void BCE0121_1()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0121-1.boo");
		}
		
		[Test]
		public void BCE0122_1()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0122-1.boo");
		}
		
		[Test]
		public void BCE0123_1()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0123-1.boo");
		}
		
		[Test]
		public void BCE0124_1()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0124-1.boo");
		}
		
		[Test]
		public void BCE0125_1()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0125-1.boo");
		}
		
		[Test]
		public void BCE0126_1()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0126-1.boo");
		}
		
		[Test]
		public void BCE0126_2()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0126-2.boo");
		}
		
		[Test]
		public void BCE0126_3()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0126-3.boo");
		}
		
		[Test]
		public void BCE0126_4()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0126-4.boo");
		}
		
		[Test]
		public void BCE0127_1()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0127-1.boo");
		}
		
		[Test]
		public void BCE0128_1()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0128-1.boo");
		}
		
		[Test]
		public void BCE0129_1()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0129-1.boo");
		}
		
		[Test]
		public void BCE0130_1()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0130-1.boo");
		}
		
		[Test]
		public void BCE0131_1()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0131-1.boo");
		}
		
		[Test]
		public void BCE0132_1()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0132-1.boo");
		}
		
		[Test]
		public void BCE0132_2()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0132-2.boo");
		}
		
		[Test]
		public void BCE0132_3()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0132-3.boo");
		}
		
		[Test]
		public void BCE0132_4()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0132-4.boo");
		}
		
		[Test]
		public void BCE0132_5()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0132-5.boo");
		}
		
		[Test]
		public void BCE0133_1()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0133-1.boo");
		}
		
		[Test]
		public void BCE0133_2()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0133-2.boo");
		}
		
		[Test]
		public void BCE0134_1()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0134-1.boo");
		}
		
		[Test]
		public void BCE0134_2()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0134-2.boo");
		}
		
		[Test]
		public void BCE0136_1()
		{
			RunCompilerTestCase(@"C:\boo-ssh\tests\testcases\errors\BCE0136-1.boo");
		}
		
	}
}
